/* This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// TrainSchedDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TrainSched.h"
#include "TrainSchedDlg.h"
#include "HyperLink.h"
/* CTokenizer is from: http://www.codeproject.com/string/tokenizer.asp */
#include "Tokenizer.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CHyperLink	m_Hyperlink;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_WEBLINK, m_Hyperlink);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTrainSchedDlg dialog

CTrainSchedDlg::CTrainSchedDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTrainSchedDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTrainSchedDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

    // Parse executable filename to generate app's INI filename.
    DWORD dwFileNameLength = GetModuleFileName( NULL, m_INIfilename.GetBuffer( MAX_PATH ), MAX_PATH );
    m_INIfilename.ReleaseBuffer( dwFileNameLength );
    // Strip of 'e' and 'x' (and CAPS versions) from end. This will remove 'exe' or 'EXE'.
    m_INIfilename.TrimRight( _T( "EX" ) );
    m_INIfilename.TrimRight( _T( "ex" ) );
    // Append "ini".
    m_INIfilename += _T( "ini" );

    
    // Ensure everything is initialized to valid values that are referenced later.
    m_bFirstPaint = TRUE;    // Set to FALSE in first OnPaint() call.
    m_bUse3Cols = FALSE;
    m_bTableInitialized = FALSE;

    // Empty arrays to ensure no random data present.
    m_saAbbreviations.RemoveAll();
    m_paTimes.RemoveAll();
    m_uaIndexArray.RemoveAll();
    uaIndexArray.RemoveAll();

    DWORD dwStrLen = GetPrivateProfileString( INI_SECTION, INI_DBFILENAME, NULL, m_dbFileName.GetBuffer( MAX_PATH ), MAX_PATH, m_INIfilename );
    m_dbFileName.ReleaseBuffer( dwStrLen );
    m_uFromStation = GetPrivateProfileInt( INI_SECTION, INI_FROM, 0, m_INIfilename );
    m_uToStation = GetPrivateProfileInt( INI_SECTION, INI_TO, 0, m_INIfilename );
    m_uDay = GetPrivateProfileInt( INI_SECTION, INI_DAY, 0, m_INIfilename );


    // Read abbreviations from INI file.
    CString csAbbrevKey, csAbbrevValue;
    INT nKey = 0;

    // First element is blank.
    m_saAbbreviations.Add( _T( "" ) );
    do
    {
        nKey++;
        csAbbrevKey.Format( _T( "%s%d" ), INI_ABBREV_BASE, nKey );
        dwStrLen = GetPrivateProfileString( INI_ABBREV_SECTION, csAbbrevKey, INI_NO_VALUE, csAbbrevValue.GetBuffer( MAX_PATH ), MAX_PATH, m_INIfilename );
        csAbbrevValue.ReleaseBuffer( dwStrLen );

        // If value exists then add it to the array.
        if ( csAbbrevValue.Compare( INI_NO_VALUE ) != 0 )
            m_saAbbreviations.Add( csAbbrevValue );
        else
            nKey = -1;
    } while ( nKey > 0 );

    // Retrieve the explanation of the abbreviations.
    dwStrLen = GetPrivateProfileString( INI_ABBREV_SECTION, INI_ABBREV_MESSAGE, INI_NO_VALUE, csAbbrevMessage.GetBuffer( 2000 ), 2000, m_INIfilename );
    csAbbrevMessage.ReleaseBuffer( dwStrLen );

    // Change pipe char to carriage return or load a string saying there is no explanation.
    if ( csAbbrevMessage.Compare( INI_NO_VALUE ) != 0 )
        csAbbrevMessage.Replace( _T( "|" ), _T( "\n" ) );
    else
        csAbbrevMessage.LoadString( IDS_ABBREV_NO_MSG );

}

void CTrainSchedDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTrainSchedDlg)
	DDX_Control(pDX, IDC_TIME_LIST, m_Timetable);
	DDX_Control(pDX, IDC_TO_COMBO, m_ToCombo);
	DDX_Control(pDX, IDC_FROM_COMBO, m_FromCombo);
	DDX_Control(pDX, IDC_DAY_COMBO, m_DayCombo);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTrainSchedDlg, CDialog)
	//{{AFX_MSG_MAP(CTrainSchedDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_REVERSE_BUTTON, OnReverseButton)
	ON_CBN_SELCHANGE(IDC_FROM_COMBO, OnSelchangeFromCombo)
	ON_CBN_SELCHANGE(IDC_DAY_COMBO, OnSelchangeDayCombo)
	ON_CBN_SELCHANGE(IDC_TO_COMBO, OnSelchangeToCombo)
	ON_WM_DESTROY()
    ON_MESSAGE(WM_DROPFILES,OnDropFiles)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTrainSchedDlg message handlers

BOOL CTrainSchedDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.
	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);


    CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strMenuItem;
        strMenuItem.LoadString( IDS_SELECT_TIMETABLE );
		if (!strMenuItem.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
            strMenuItem.LoadString( IDS_SELECT_TIMETABLE );
            pSysMenu->AppendMenu( MF_STRING, IDM_SEL_TIMETABLE, strMenuItem );
            strMenuItem.LoadString( IDS_ABBREVIATIONS );
            pSysMenu->AppendMenu( MF_STRING, IDM_ABBREVIATIONS, strMenuItem );
            // Initially disable the Abbreviations menu item,
            // enabling it when a 3 column database is loaded.
            pSysMenu->EnableMenuItem( IDM_ABBREVIATIONS, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED );
            strMenuItem.LoadString(IDS_ABOUTBOX);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strMenuItem );
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

    // Indicate that the dialog accepts dropped files from Windows Explorer.
    DragAcceptFiles();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTrainSchedDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	switch (nID & 0xFFFF)
	{
        case IDM_ABOUTBOX:
            { CAboutDlg dlgAbout;
            dlgAbout.DoModal(); }
            break;
        case IDM_ABBREVIATIONS:
            { CString sTitle( (LPCSTR) IDS_TRAINSCHED );
            MessageBox( csAbbrevMessage, sTitle ); }
            break;
        case IDM_SEL_TIMETABLE:
            {
                CString csTypes( (LPCSTR) IDS_FILE_TYPES );
                CFileDialog dlgDBFile( TRUE, NULL, NULL, OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY, csTypes, this );
                if ( dlgDBFile.DoModal() == IDOK )
                {
                    m_dbFileName = dlgDBFile.GetPathName();

                    if ( ReadTimetableFile() )
                    {
                        // Display first route and default direction as new timetable loaded.
                        m_uDay = 0;
                        m_uFromStation = 0;
                        m_uToStation = 0;
                        SetComboBoxSelection();
                        ReloadTimetable();
                    }
                    else
                    {
                        EmptyComboBoxes();
                        DisableControls();
                    }
                }
            }
            break;
        default:
            CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTrainSchedDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
        // Load timetable as dialog is first painted. This allows error messages
        // to appear on top of the dialog instead of alone, without any dialog.
        if ( m_bFirstPaint )
        {
            m_bFirstPaint  = FALSE;
            if ( m_dbFileName.GetLength() == 0 )
            {
                // Prompt the user to choose a data file, quitting if they don't.
                CString sMsg;
                sMsg.LoadString( IDS_NO_FILE_PREF );
                CString sTitle( (LPCSTR) IDS_TRAINSCHED_ERROR );
                MessageBox( sMsg, sTitle );
                SendMessage( WM_SYSCOMMAND, (WPARAM) IDM_SEL_TIMETABLE, 0 );
                if ( m_dbFileName.GetLength() == 0 )
                {
                    sMsg.LoadString( IDS_NO_DATA_FILE );
                    MessageBox( sMsg, sTitle );
                    OnOK();
                }
            }

            if ( ReadTimetableFile() )
            {
                SetComboBoxSelection();
                ReloadTimetable();
            }
            else
            {
                EmptyComboBoxes();
                DisableControls();
            }
        }
        CDialog::OnPaint();
    }
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTrainSchedDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CTrainSchedDlg::ReadTimetableFile()
{
    CFile dbFile;
    CFileException e;
    UINT i;

    // Ensure the filename is set.
    if ( m_dbFileName.GetLength() == 0 )
        return FALSE;

    if ( ! dbFile.Open( m_dbFileName, CFile::modeRead | CFile::shareDenyWrite, &e ) )
    {
        CString sErrorMsg;
        e.GetErrorMessage( sErrorMsg.GetBuffer( 1024 ), 1024 );
        sErrorMsg.ReleaseBuffer();
        CString sTitle( (LPCSTR) IDS_TRAINSCHED_ERROR );
        CString sMsg( (LPCSTR) IDS_SELECT_ANOTHER_FILE );
        sErrorMsg += _T( "\n" ) + sMsg;
        MessageBox( sErrorMsg, sTitle );

        SendMessage( WM_SYSCOMMAND, (WPARAM) IDM_SEL_TIMETABLE, 0 );

        if ( ReadTimetableFile() )
            ReloadTimetable();
        else
        {
            EmptyComboBoxes();
            DisableControls();
        }

        return FALSE;    // TODO: Is this right?
    }

    if ( CFile::hFileNull == dbFile.m_hFile )
    {
        CString sTitle( (LPCSTR) IDS_TRAINSCHED_ERROR );
        CString sErrorMsg( (LPCSTR) IDS_ERROR_OPEN_FILE );
        MessageBox( sErrorMsg, sTitle );

        return FALSE;
    }
    else
    {
        ClearUpTimetableData();
        CString sTitle( (LPCSTR) IDS_TRAINSCHED_ERROR ), sErrorMsg;

        DWORD dwDbFileLength = dbFile.GetLength();

        // Cannot process an empty file.
        if ( dwDbFileLength == 0 )
        {
            sErrorMsg.LoadString( IDS_ERROR_EMPTY_FILE );
            MessageBox( sErrorMsg, sTitle );
            return FALSE;
        }
        LPTSTR lpdbFileData = (LPTSTR) new TCHAR [ dwDbFileLength + 1 ];
        lpdbFileData[ dwDbFileLength ] = NULL;
        if ( dbFile.Read( lpdbFileData, dwDbFileLength ) != dwDbFileLength )
        {
            dbFile.Close();
            sErrorMsg.LoadString( IDS_ERROR_READ_PROBLEM );
            MessageBox( sErrorMsg, sTitle );
            return FALSE;
        }
        dbFile.Close();

        CPtrArray paLines;
		LPTSTR lpNull;
		LPTSTR lpCurrent = lpdbFileData;
        LPTSTR lpStrStart = lpCurrent;

        while ( lpCurrent < ( lpdbFileData + dwDbFileLength ) )
		{
            // Look for 0x0A and 0x0D for Windows and Unix line end chars.
			while ( ( *lpCurrent ) && ( *lpCurrent != 0x0A ) && ( *lpCurrent != 0x0D ) )
			    lpCurrent++;
			lpNull = lpCurrent;
			lpCurrent++;
            // Move past the second line end char if present.
			if ( ( *lpCurrent == 0x0D ) || ( *lpCurrent == 0x0A ) )
				    lpCurrent++;
			*lpNull = NULL;
            paLines.Add( lpStrStart );
            lpStrStart = lpCurrent;
		}

        // Must be at least 4 lines (GetUpperBound returns count - 1 because
        // it is 0 based). Four lines: Stations, Days, Indices, Time1.
        if ( paLines.GetUpperBound() < 3 )
            return FALSE;

		CString csSplit;
		// Parse out the stations.
		{
			CTokenizer tok( (LPCTSTR) paLines.GetAt( 0 ), _T( "\t" ) );

            while ( tok.Next( csSplit ) )
            {
                // Don't add "DUMMY" to the combo boxes.
                if ( csSplit.Compare( _T( "DUMMY" ) ) == 0 )
                    m_bUse3Cols = TRUE;
                else
                {
                    m_ToCombo.AddString( csSplit );
                    m_FromCombo.AddString( csSplit );
                }
            }

            // Validate m_FromStation and m_ToStation and set combo box current selection.
            if ( ( m_uFromStation < 0 ) || ( m_uFromStation >= m_FromCombo.GetCount() ) )
                m_uFromStation = 0;
            m_FromCombo.SetCurSel( m_uFromStation );
            m_FromCombo.EnableWindow();
            if ( ( m_uToStation < 0 ) || ( m_uToStation >= m_ToCombo.GetCount() ) )
                m_uToStation = 0;
			m_ToCombo.SetCurSel( m_uToStation );
            m_ToCombo.EnableWindow();
		}

        // Enable the Abbreviations menu item to explain 3rd column.
        CMenu* pSysMenu = GetSystemMenu(FALSE);
        if (pSysMenu != NULL)
            if ( m_bUse3Cols )
                pSysMenu->EnableMenuItem( IDM_ABBREVIATIONS, MF_BYCOMMAND | MF_ENABLED );
            else
                pSysMenu->EnableMenuItem( IDM_ABBREVIATIONS, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED );

        // Parse out the days.
		{
			CTokenizer tok( (LPCTSTR) paLines.GetAt( 1 ), _T( "\t" ) );

			while ( tok.Next( csSplit ) )
				m_DayCombo.AddString( csSplit );
            // Validate m_uDay and set combo box current selection.
            if ( ( m_uDay < 0 ) || ( m_uDay >= m_DayCombo.GetCount() ) )
                m_uDay = 0;
			m_DayCombo.SetCurSel( m_uDay );
            m_DayCombo.EnableWindow();
		}

        // Enable the Reverse button.
        GetDlgItem( IDC_REVERSE_BUTTON )->EnableWindow();

        // Parse out index numbers.
		{
			CTokenizer tok( (LPCTSTR) paLines.GetAt( 2 ), _T( "\t" ) );

			while ( tok.Next( csSplit ) )
				m_uaIndexArray.Add( _ttoi( csSplit ) );
		}

        // There must be twice as many indices as days (two directions - outbound and return).
        if ( ( m_uaIndexArray.GetUpperBound() + 1 ) != ( 2 * m_DayCombo.GetCount() ) )
        {
            sErrorMsg.LoadString( IDS_ERROR_BAD_INDICES );
            MessageBox( sErrorMsg, sTitle );

            // Remove NULLs so memory can be freed.
    		memset( lpdbFileData, 'x', dwDbFileLength );
	    	::delete( lpdbFileData );

            return FALSE;
        }


        // Parse out times.
		for ( i = 0; i <= m_uaIndexArray.GetUpperBound(); i++ )
		{
			UINT uEndLine;
			if ( i == m_uaIndexArray.GetUpperBound() )
				uEndLine = paLines.GetUpperBound() + 1;
			else
				uEndLine = m_uaIndexArray.GetAt( i + 1 ) - 1;

			CPtrArray *p_paOneDir = new CPtrArray;
			m_paTimes.Add( p_paOneDir );

            // Parse out lines grouped by the index numbers.
			for ( UINT uLine = m_uaIndexArray[ i ] - 1; uLine < uEndLine; uLine++ )
			{
				CStringArray *p_saOneTrain = new CStringArray;

                CTokenizer tok( (LPCTSTR) paLines.GetAt( uLine ), _T( "\t" ) ); // A tab as token.

				while ( tok.Next( csSplit ) )
					p_saOneTrain->Add( csSplit );

                // Ensure number of items on the line are valid.
                UINT uExpectedTimes = m_FromCombo.GetCount() - 1;
                // If 3 cols, the extra 'time' will be the annotation item.
                if ( m_bUse3Cols )
                    uExpectedTimes++;
                // Only add p_saOneTrain if the expected number of times are are on this line.
                if ( uExpectedTimes == p_saOneTrain->GetUpperBound() )
				    p_paOneDir->Add( p_saOneTrain );
			}
		}

        // Remove NULLs so memory can be freed.
		memset( lpdbFileData, 'x', dwDbFileLength );
		::delete( lpdbFileData );

        // Initialise the table. Only needs to be done once.
        if ( ! m_bTableInitialized )
        {
    	    UINT col;
    	    LV_COLUMN lvc;
            lvc.fmt = LVCFMT_LEFT;
            lvc.mask = LVCF_WIDTH | LVCF_FMT;
            // Split table into 3 even columns.
            RECT rect;
            m_Timetable.GetClientRect( &rect );
            UINT uTableColumns = ( m_bUse3Cols ? 3 : 2 );
            lvc.cx = rect.right / uTableColumns;

            // Add the columns. One column implied so add cols 2 and 3.
            for ( col = 1; col <= uTableColumns; col++ )
            {
                lvc.iSubItem = col;
                m_Timetable.InsertColumn( 0, &lvc );
            }
            m_bTableInitialized = TRUE;
        }
    }

    return TRUE;
}

void CTrainSchedDlg::OnReverseButton() 
{
    // Reverse the combo box selections before reloading the timetable.
    int nSel = m_FromCombo.GetCurSel();
    m_FromCombo.SetCurSel( m_ToCombo.GetCurSel() );
    m_ToCombo.SetCurSel( nSel );

    m_uFromStation = m_FromCombo.GetCurSel();
    m_uToStation = m_ToCombo.GetCurSel();

    ReloadTimetable();
}

void CTrainSchedDlg::ReloadTimetable()
{
    // Delete all of the items from the list view control.
    m_Timetable.DeleteAllItems();

    // Don't display anything if the same station is in both combo boxes.
    if ( m_uFromStation == m_uToStation )
        return;

    UINT uDirection = 0;
    UINT uFromIndex = m_uFromStation;
    UINT uToIndex = m_uToStation;

    if ( uFromIndex > uToIndex )
    {
        uDirection = ( m_uaIndexArray.GetUpperBound() + 1 ) / 2;
        // Text file lists reverse direction time columns in
        // reverse order so must reference differently.
        uFromIndex = m_FromCombo.GetCount() - m_uFromStation - 1;
        uToIndex = m_ToCombo.GetCount() - m_uToStation - 1;
    }
    CPtrArray *pa = (CPtrArray *) m_paTimes.GetAt( m_uDay + uDirection );

    CString csFromTime, csToTime, csAbbrev;
    UINT uRow = 0;
    LVITEM lvi;
    lvi.mask = LVIF_TEXT;

    INT nCol0 = 0, nCol1 = 0, nCol2 = 0, nWidth;
    for ( UINT uTrainNumber = 0; uTrainNumber <= pa->GetUpperBound(); uTrainNumber++ )
    {
        CStringArray *sa = (CStringArray *) pa->GetAt( uTrainNumber );

        csFromTime = sa->GetAt( uFromIndex );
        csToTime = sa->GetAt( uToIndex );

        // Only add if train stops at both stations. '-' is in string if not stopping.
        if ( ( csFromTime.Find( _T( '-' ) ) == -1 ) &&
           ( csToTime.Find( _T( '-' ) ) == -1 ) )
        {
            lvi.iItem = uRow;    // Row.

            // Add the From time.
            lvi.iSubItem = 0;  // Column
            lvi.pszText = _T( "" );
            lvi.cchTextMax = sizeof( _T( "" ) );
            m_Timetable.InsertItem( &lvi );
            FormatTime( csFromTime );
            // Get width of this string.
            nWidth = m_Timetable.GetStringWidth( csFromTime );
            if ( nWidth > nCol0 )
                nCol0 = nWidth;
            m_Timetable.SetItemText( uRow, lvi.iSubItem, csFromTime );

            // Add the To time.
            lvi.iSubItem = 1;  // Column
            m_Timetable.InsertItem( &lvi );
            FormatTime( csToTime );
            // Get width of this string.
            nWidth = m_Timetable.GetStringWidth( csToTime );
            if ( nWidth > nCol1 )
                nCol1 = nWidth;
            m_Timetable.SetItemText( uRow, lvi.iSubItem, csToTime );

            // Add the annotation string.
            if ( m_bUse3Cols )
            {
                lvi.iSubItem = 2;  // Column
                m_Timetable.InsertItem( &lvi );

                // Validate the abbreviation number.
                INT nAbbrevIndex = _ttoi( sa->GetAt( sa->GetUpperBound() ) );
                // Use the blank abbreviation if the number is invalid.
                if ( ( nAbbrevIndex < 0 ) || ( nAbbrevIndex > m_saAbbreviations.GetUpperBound() ) ) 
                    nAbbrevIndex = BLANK_ABBREV;
                csAbbrev = m_saAbbreviations.GetAt( nAbbrevIndex );
                // Get width of this string.
                nWidth = m_Timetable.GetStringWidth( csAbbrev );
                if ( nWidth > nCol2 )
                    nCol2 = nWidth;
                m_Timetable.SetItemText( uRow, lvi.iSubItem, csAbbrev );
            }
            uRow++;
        }
    }

    // Change the column widths, with padding so data not abbreviated.
    m_Timetable.SetColumnWidth( 0, nCol0 + 25 );
    m_Timetable.SetColumnWidth( 1, nCol1 + 25 );
    m_Timetable.SetColumnWidth( 2, nCol2 + 25 );
}

void CTrainSchedDlg::OnSelchangeFromCombo() 
{
    m_uFromStation = m_FromCombo.GetCurSel();

    ReloadTimetable();
}

void CTrainSchedDlg::OnSelchangeDayCombo() 
{
    m_uDay = m_DayCombo.GetCurSel();

    ReloadTimetable();
}

void CTrainSchedDlg::OnSelchangeToCombo() 
{
    m_uToStation = m_ToCombo.GetCurSel();

    ReloadTimetable();
}

void CTrainSchedDlg::ClearUpTimetableData()
{
    // Only clean up if it is populated.
    // Otherwise get error with invalid GetUpperBound() result.
    UINT i;
    if ( m_paTimes.GetData() != NULL )
    {
        // Clean up the CPtrArray variables.
		for ( i = 0; i <= m_paTimes.GetUpperBound(); i++ )
		{
            CPtrArray *pa = (CPtrArray *) m_paTimes.GetAt( i );
			for ( UINT j = 0; j <= pa->GetUpperBound(); j++ )
			{
                CStringArray *sa = (CStringArray *) pa->GetAt( j );
				sa->RemoveAll();
				delete sa;
            }
			pa->RemoveAll();
			delete pa;
        }
    }
    m_paTimes.RemoveAll();

    m_uaIndexArray.RemoveAll();

    // Clear the contents of the combo boxes.
    EmptyComboBoxes();
}

BOOL CTrainSchedDlg::SetComboBoxSelection()
{
    // Set combo boxes to stored values if valid.
    if ( ( m_uDay < 0 ) || ( m_uDay >= (UINT) m_DayCombo.GetCount() ) )
        m_uDay = 0;
    m_DayCombo.SetCurSel( m_uDay );
    if ( ( m_uFromStation < 0 ) || ( m_uFromStation >= (UINT) m_FromCombo.GetCount() ) )
        m_uFromStation = 0;
    m_FromCombo.SetCurSel( m_uFromStation );
    if ( ( m_uToStation < 0 ) || ( m_uToStation >= (UINT) m_ToCombo.GetCount() ) )
        m_uToStation = 0;
    m_ToCombo.SetCurSel( m_uToStation );

    return TRUE;
}

void CTrainSchedDlg::FormatTime( CString &csTime )
{
    INT nColon = csTime.Find( _T( ':' ) );
    if ( nColon != -1 )
    {
        SYSTEMTIME stTime;
        // Populate struct with valid values in case GetTimeFormat() uses them. */
        GetLocalTime( &stTime );

        stTime.wHour = _ttoi( csTime.Left( nColon ) );
        stTime.wMinute = _ttoi( csTime.Mid( nColon + 1 ) );
        /* Format time, without seconds, in user's chosen locale format. */
        GetTimeFormat( GetThreadLocale(), TIME_NOSECONDS, &stTime, NULL, csTime.GetBuffer( MAX_PATH ), MAX_PATH );
        csTime.ReleaseBuffer();
    }
}

// Called when Esc key or Quit button pressed.
void CTrainSchedDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
    ClearUpTimetableData();

    // Store preferences.
    WritePrivateProfileString( INI_SECTION, INI_DBFILENAME, m_dbFileName, m_INIfilename );
    CString csPrefStr;
    csPrefStr.Format( _T( "%u" ), m_uDay );
    WritePrivateProfileString( INI_SECTION, INI_DAY, csPrefStr, m_INIfilename );
    csPrefStr.Format( _T( "%u" ), m_uFromStation );
    WritePrivateProfileString( INI_SECTION, INI_FROM, csPrefStr, m_INIfilename );
    csPrefStr.Format( _T( "%u" ), m_uToStation );
    WritePrivateProfileString( INI_SECTION, INI_TO, csPrefStr, m_INIfilename );
}

// Called when a file is dragged onto the dialog from Windows Explorer.
void CTrainSchedDlg::OnDropFiles(HDROP hDropInfo)
{
    // Store previous database so it can be reloaded in case of an error.
    CString csOldDbFileName = m_dbFileName;

    DragQueryFile( hDropInfo, 0, m_dbFileName.GetBuffer( MAX_PATH ), MAX_PATH );
    m_dbFileName.ReleaseBuffer();

    ClearUpTimetableData();
    if ( ReadTimetableFile() )
    {
        // Display first route and default direction as new timetable loaded.
        m_uDay = 0;
        m_uFromStation = 0;
        m_uToStation = 0;
        SetComboBoxSelection();
        ReloadTimetable();
    }
    else
    {
        EmptyComboBoxes();
        DisableControls();
        // Tell user that data file is bad and reload previous file.
        CString sTitle( (LPCSTR) IDS_TRAINSCHED_ERROR );
        CString sMsg( (LPCSTR) IDS_ERROR_BAD_FILE );
        MessageBox( sMsg, sTitle );
        m_dbFileName = csOldDbFileName;
        if ( ReadTimetableFile() )
        {
            SetComboBoxSelection();
            ReloadTimetable();
        }
        else
            EmptyComboBoxes();
    }
}

void CTrainSchedDlg::DisableControls()
{
    m_DayCombo.EnableWindow( FALSE );
    m_ToCombo.EnableWindow( FALSE );
    m_FromCombo.EnableWindow( FALSE );
    GetDlgItem( IDC_REVERSE_BUTTON )->EnableWindow( FALSE );
    // Disable the Abbreviations menu.
    GetSystemMenu(FALSE)->EnableMenuItem( IDM_ABBREVIATIONS, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED );
}

void CTrainSchedDlg::EmptyComboBoxes()
{
    UINT i;
    UINT uComboCount = m_DayCombo.GetCount();
    for ( i = 0; i <= uComboCount; i++ )
        m_DayCombo.DeleteString( 0 );
    uComboCount = m_FromCombo.GetCount();
    for ( i = 0; i <= uComboCount; i++ )
    {
        m_FromCombo.DeleteString( 0 );
        m_ToCombo.DeleteString( 0 );
    }

}
