/* This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// TrainSchedDlg.h : header file
//

#if !defined(AFX_TRAINSCHEDDLG_H__D4D9D94F_E563_45BD_926C_7B7BE88B8DF4__INCLUDED_)
#define AFX_TRAINSCHEDDLG_H__D4D9D94F_E563_45BD_926C_7B7BE88B8DF4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CTrainSchedDlg dialog

// INI file key and section names.
#define INI_SECTION          _T( "TrainSched" )
#define INI_DBFILENAME       _T( "dbFileName" )
#define INI_FROM             _T( "uFrom" )
#define INI_TO               _T( "uTo" )
#define INI_DAY              _T( "uDay" )
#define INI_ABBREV_SECTION   _T( "Abbreviations" )
#define INI_ABBREV_BASE      _T( "szAbbrev" )
#define INI_ABBREV_MESSAGE   _T( "Message" )
#define INI_NO_VALUE         _T( "NO_VALUE" )

// Abbreviations Index
#define BLANK_ABBREV         0

// System menu items.
#define IDM_SEL_TIMETABLE    0x0011
#define IDM_ABBREVIATIONS    0x0012


class CTrainSchedDlg : public CDialog
{
// Construction
public:
	void FormatTime( CString &csTime );
	CTrainSchedDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CTrainSchedDlg)
	enum { IDD = IDD_TRAINSCHED_DIALOG };
	CListCtrl	m_Timetable;
	CComboBox	m_ToCombo;
	CComboBox	m_FromCombo;
	CComboBox	m_DayCombo;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTrainSchedDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void DisableControls();
	void OnDropFiles( HDROP hDropInfo );
	CString m_INIfilename;
	CString m_dbFileName;
	BOOL m_bFirstPaint;
	void ReloadTimetable();
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CTrainSchedDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnReverseButton();
	afx_msg void OnSelchangeFromCombo();
	afx_msg void OnSelchangeDayCombo();
	afx_msg void OnSelchangeToCombo();
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	void EmptyComboBoxes();
	CString csAbbrevMessage;
	BOOL m_bTableInitialized;
	BOOL SetComboBoxSelection();
	CStringArray m_saAbbreviations;
	void ClearUpTimetableData();
	CUIntArray m_uaIndexArray;
	CUIntArray uaIndexArray;
	BOOL m_bUse3Cols;
	CPtrArray m_paTimes;
	UINT m_uDay;
	UINT m_uToStation;
	UINT m_uFromStation;
	BOOL ReadTimetableFile();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TRAINSCHEDDLG_H__D4D9D94F_E563_45BD_926C_7B7BE88B8DF4__INCLUDED_)
